
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientFloat64. See ClientByte.cc
//
// jhrg 1/12/95

// $Log: ClientFloat64.cc,v $
// Revision 1.15  1999/04/30 17:06:55  jimg
// Merged with no-gnu and release-2-24
//
// Revision 1.14  1999/03/19 17:40:00  jimg
// Added a call to ios::precision(). This sets the output precision of float
// values to 15 (the default, 6, was rounding some values).
//
// Revision 1.13  1998/11/20 08:41:22  jimg
// Fixed the fix for the extra newline separators; it was broken for arrays
//
// Revision 1.12  1998/11/19 20:53:33  jimg
// Fixed the extra newline bug.
//
// Revision 1.11  1998/09/16 23:02:19  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.10  1998/08/03 16:39:45  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.9  1997/10/04 00:40:00  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.8  1997/06/06 04:01:21  jimg
// Added ASCII output option to writeval. Uses a global `flag'.
//
// Revision 1.7  1997/04/19 00:54:50  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.6  1997/02/06 20:43:33  jimg
// Fixed log messages
//
// Revision 1.5  1997/01/10 06:49:29  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.4  1996/11/23 05:12:04  jimg
// Added support for variable renaming via the name_map object.
//
// Revision 1.3  1996/10/23 23:46:37  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:00:23  jimg
// Fixed Headers.
//
// Revision 1.1  1996/09/30 23:58:59  jimg
// Added.

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>
#include <iomanip.h>
#include <string>

#include <Pix.h>
#include <SLList.h>

#include "ClientFloat64.h"
#include "name_map.h"

extern name_map names;
extern bool translate;
extern bool ascii;

Float64 *
NewFloat64(const string &n)
{
    return new ClientFloat64(n);
}

ClientFloat64::ClientFloat64(const string &n) : Float64(n)
{
}

BaseType *
ClientFloat64::ptr_duplicate()
{
    return new ClientFloat64(*this);
}
 
bool
ClientFloat64::read(const string &, int &)
{
    assert(false);
    return false;
}

void 
ClientFloat64::print_val(ostream &os, string, bool print_decl_p)
{
    os.precision(15);

    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (ascii)
	os << _buf << " ";
    else
	os.write((void *)&_buf, sizeof(dods_float64));
}
